package FACS.Plot;

import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import java.io.BufferedOutputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.net.URL;
import java.util.Hashtable;
import FACS.Plot.PlotApplet.*;

import javax.imageio.ImageIO;
import javax.servlet.*;
import javax.servlet.http.*;

public class PlotImagelet extends HttpServlet {
	
	public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		doPost(request,response);
	}

	public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		Hashtable params = new Hashtable();
		params.put("compact","true");
		params.put("plotservlet","PlotServlet"); //because our url already has /servlets/
		params.put("headerlet","Headerlet");
		params.put("regionlet","Regionlet");
		params.put("codebase",new URL(request.getRequestURL().toString()));
		params.put("directory", request.getParameter("directory"));
		params.put("file", request.getParameter("file"));
		params.put("param1", request.getParameter("param1"));
		params.put("param2", request.getParameter("param2"));
		params.put("mode", request.getParameter("mode"));
		if(request.getParameter("smooth") != null)
			params.put("smooth", request.getParameter("smooth"));
		if(request.getParameter("region") != null)
			params.put("region", request.getParameter("region"));
		if(request.getParameter("gates") != null)
			params.put("gates", request.getParameter("gates"));
		
		PlotApplet applet = new PlotApplet(params);
		applet.init();
		
		response.setContentType("image/jpeg");
		BufferedImage bi = new BufferedImage(Plot.getPSize().width,Plot.getPSize().height,BufferedImage.TYPE_INT_RGB);
		//BufferedImage bi = applet.getPlot(new int[] { 0 }, 1, 2, 1);
		Graphics2D g2 = (Graphics2D)bi.getGraphics();
		applet.paintPlot(g2);
		ByteArrayOutputStream baos = new ByteArrayOutputStream();
		ImageIO.write(bi,"jpg",baos);
		response.setContentLength(baos.size());
		BufferedOutputStream bos = new BufferedOutputStream(response.getOutputStream());
		bos.write(baos.toByteArray());
		bos.close();
		baos.close();
		
		applet = null;
		params = null;
		bi = null; baos = null; bos = null;
	}
}
