/**
 * Functions for drawing a Contour plot.
 * Access by ContourPlotter.getContourPoints(...)
 * 
 * @author Mark
 *
 */

package FACS.Plot.PlotServlet;

import java.util.Vector;

public class ContourPlotter {
	public static final int[] start = { -1, -1 }; //signals start of a new level curve
	
    public static int[][] getContourPoints(int[][] hist, int[] levels, boolean outliers) {
		//outliers = false;

    	int[][] oldhist = null;
    	if(outliers)
    		oldhist = hist;
		hist = blur(hist);
		
		Vector c = new Vector();

		for(int i = 0; i < hist.length; i++) {
			for(int j = 0; j < hist[i].length; j++) {
				if(outliers) {
					if(oldhist[i][j] > 0 && hist[i][j] < levels[0]) {
						int[] p = { i, j };
						//c.add(start);
						c.add(p);
					}
				}
				if(atLevel(hist,i,j,levels)) {
					int[] p = { i, j };
					//c.add(start);
					c.add(p);
				}
			}
		}

		
		/*
        //int[][] c = new int[hist.length][hist[0].length];
        //Vector c = new Vector();
        Vector used = new Vector();
        int n = 0;
        
        Vector stack, stack2; //stack of points to do
        for(int l = 0; l < levels.length; l++) { //for each level
        	levels[l] = 4;
            for(int i = 0; i < hist.length; i++) { //scan points
                for(int j = 0; j < hist[i].length; j++) { //scan points
                    if(hist[i][j] == 0)
                        continue;
                    int[] p2 = {i, j};
                    //if(inList(used, p2))
                    //    continue;
                    outliers = false;
                    if(l == 0 && hist[i][j] < levels[0] && outliers) {//outliers
                        int[] p = { i, j };
                        c.add(start);
                        c.add(p);
                        used.add(p);
                    } else {
                        if(isIsect(hist,i,j,levels[l])) { //current vertex is part of level curve
                            stack = new Vector();
                            int[] p1 = { i, j };
                            if(!inList(used,p1)) {
                                stack.add(p1);
                                used.add(p1);
                                used.add(pIsect(hist,i,j,levels[l]));
                            }
                            while(stack.size() > 0) { //stack is all branches we haven't gotten to yet
                                int[] cur = (int[])stack.remove(0);
                                c.add(start);
                                stack2 = new Vector();
                                stack2.add(cur);
                                while(stack2.size() > 0) { //travel around level curve
                                    int[] cur2 = (int[])stack2.remove(0);
                                    c.add(cur2);
                                    i = cur2[0]; j = cur2[1];
                                    if(i != 0 && isIsect(hist,i-1,j,levels[l])) {
                                        int[] p = { i-1, j };
                                        if(!inList(used,p) && !inList(stack,p)) {
                                            stack.add(p);
                                            used.add(p);
                                            used.add(pIsect(hist,i-1,j,levels[l]));
                                        }
                                    }
                                    if(j != 0 && isIsect(hist,i,j-1,levels[l])) {
                                        int[] p = { i, j-1 };
                                        if(!inList(used,p) && !inList(stack,p)) {
                                            stack.add(p);
                                            used.add(p);
                                            used.add(pIsect(hist,i,j-1,levels[l]));
                                        }
                                    }
                                    if(i != hist.length-1 && isIsect(hist,i+1,j,levels[l])) {
                                        int[] p = { i+1, j };
                                        if(!inList(used,p) && !inList(stack,p)) {
                                            stack.add(p);
                                            used.add(p);
                                            used.add(pIsect(hist,i+1,j,levels[l]));
                                        }
                                    }
                                    if(j!= hist[0].length-1 && isIsect(hist,i,j+1,levels[l])) {
                                        int[] p = { i, j+1 };
                                        if(!inList(used,p) && !inList(stack,p)) {
                                            stack.add(p);
                                            used.add(p);
                                            used.add(pIsect(hist,i,j+1,levels[l]));
                                        }
                                    }
                                    if(j != 0 && i != 0 && isIsect(hist,i-1,j-1,levels[l])) {
                                        int[] p = { i-1, j-1 };
                                        if(!inList(used,p) && !inList(stack,p)) {
                                            stack.add(p);
                                            used.add(p);
                                            used.add(pIsect(hist,i-1,j-1,levels[l]));
                                        }
                                    }
                                    if(j!= hist[0].length-1 && i != hist.length-1 && isIsect(hist,i+1,j+1,levels[l])) {
                                        int[] p = { i+1, j+1 };
                                        if(!inList(used,p) && !inList(stack,p)) {
                                            stack.add(p);
                                            used.add(p);
                                            used.add(pIsect(hist,i+1,j+1,levels[l]));
                                        }
                                    }
                                    if(i != hist.length-1 && j != 0 && isIsect(hist,i+1,j-1,levels[l])) {
                                        int[] p = { i+1, j-1 };
                                        if(!inList(used,p) && !inList(stack,p)) {
                                            stack.add(p);
                                            used.add(p);
                                            used.add(pIsect(hist,i+1,j-1,levels[l]));
                                        }
                                    }
                                    if(j!= hist[0].length-1 && i != 0 && isIsect(hist,i-1,j+1,levels[l])) {
                                        int[] p = { i-1, j+1 };
                                        if(!inList(used,p) && !inList(stack,p)) {
                                            stack.add(p);
                                            used.add(p);
                                            used.add(pIsect(hist,i-1,j+1,levels[l]));
                                        }
                                    }
                                    if(stack.size() > 0)
                                        stack2.add(stack.remove(0));
                                }
                            }
                        }
                    }
                }
            }
        }*/
        
        int[][] a = new int[c.size()][2];
        for(int i = 0; i < c.size(); i++) {
            int[] p = (int[])c.elementAt(i);
            a[i][0] = p[0];
            a[i][1] = p[1];
        }

        return a;
    }
    
    public static int[][] blur(int[][] in) {
    	int[][] out = new int[in.length][in[0].length];
    	int blurSize = 2;
    	double divby = (double)(2*blurSize+1)*(2*blurSize+1);
    	
    	double sum;
    	for(int i = blurSize; i < in.length-blurSize; i++) {
    		for(int j = blurSize; j < in[i].length-blurSize; j++) {
    			sum = 0;
    			for(int a = i-blurSize; a <= i+blurSize; a++) {
    				for(int b = j-blurSize; b <= j+blurSize; b++) {
    					sum += in[a][b];
    				}
    			}
    			sum /= divby;
    			out[i][j] = (int)sum;
    		}
    	}
    	return out;
    }
    
    public static boolean inList(Vector v, int[] p) {
        for(int i = 0; i < v.size(); i++) {
            int[] vi = (int[])v.elementAt(i);
            if(vi[0] == p[0] && vi[1] == p[1])
                return true;
        }
        return false;
    }
    
    /*public static boolean isIsect(int[][] hist, int i, int j, int level) {
        if(i != 0 && ((hist[i][j] > level && hist[i-1][j] < level)
            || (hist[i][j] < level && hist[i-1][j] > level))) {
                return true;
        }
        if(i != hist.length-1 && ((hist[i][j] > level && hist[i+1][j] < level)
            || (hist[i][j] < level && hist[i+1][j] > level))) {
                return true;
        }
        if(j != 0 && i != 0 && ((hist[i][j] > level && hist[i-1][j-1] < level)
            || (hist[i][j] < level && hist[i-1][j-1] > level))) {
                return true;
        }
        if(j != hist[0].length-1 && i != 0 && ((hist[i][j] > level && hist[i-1][j+1] < level)
            || (hist[i][j] < level && hist[i-1][j+1] > level))) {
                return true;
        }
        if(i != hist.length-1 && j != 0 && ((hist[i][j] > level && hist[i+1][j-1] < level)
            || (hist[i][j] < level && hist[i+1][j-1] > level))) {
                return true;
        }
        if(j != hist[0].length-1 && i != hist.length-1 && ((hist[i][j] > level && hist[i+1][j+1] < level)
            || (hist[i][j] < level && hist[i+1][j+1] > level))) {
                return true;
        }
        if(j != 0 && ((hist[i][j] > level && hist[i][j-1] < level)
            || (hist[i][j] < level && hist[i][j-1] > level))) {
                return true;
        }
        if(j != hist[0].length-1 && ((hist[i][j] > level && hist[i][j+1] < level)
            || (hist[i][j] < level && hist[i][j+1] > level))) {
                return true;
        }
        return false;
    }*/
    
    public static int[] pIsect(int[][] hist, int i, int j, int level) {
        if(i != 0 && ((hist[i][j] > level && hist[i-1][j] < level)
            || (hist[i][j] < level && hist[i-1][j] > level))) {
                int[] p = { i-1, j };
                return p;
        }
        if(i != hist.length-1 && ((hist[i][j] > level && hist[i+1][j] < level)
            || (hist[i][j] < level && hist[i+1][j] > level))) {
                int[] p = { i+1, j };
                return p;
        }
        if(j != 0 && i != 0 && ((hist[i][j] > level && hist[i-1][j-1] < level)
            || (hist[i][j] < level && hist[i-1][j-1] > level))) {
                int[] p = { i-1, j-1 };
                return p;
        }
        if(j != hist[0].length-1 && i != 0 && ((hist[i][j] > level && hist[i-1][j+1] < level)
            || (hist[i][j] < level && hist[i-1][j+1] > level))) {
                int[] p = { i-1, j+1 };
                return p;
        }
        if(i != hist.length-1 && j != 0 && ((hist[i][j] > level && hist[i+1][j-1] < level)
            || (hist[i][j] < level && hist[i+1][j-1] > level))) {
                int[] p = { i+1, j-1 };
                return p;
        }
        if(j != hist[0].length-1 && i != hist.length-1 && ((hist[i][j] > level && hist[i+1][j+1] < level)
            || (hist[i][j] < level && hist[i+1][j+1] > level))) {
                int[] p = { i+1, j+1 };
                return p;
        }
        if(j != 0 && ((hist[i][j] > level && hist[i][j-1] < level)
            || (hist[i][j] < level && hist[i][j-1] > level))) {
                int[] p = { i, j-1 };
                return p;
        }
        if(j != hist[0].length-1 && ((hist[i][j] > level && hist[i][j+1] < level)
            || (hist[i][j] < level && hist[i][j+1] > level))) {
                int[] p = { i, j+1 };
                return p;
        }
        return null;
    }
    
    public static boolean isIsect(int[][] hist, int i, int j, int level) {
    	if(i == 0 || j == 0 || i == hist.length-1 || j == hist[0].length-1)
    		return false;
    	
    	int less = 0;
    	int greater = 0;
    	int equal = 0;
    	for(int a = i-1; a <= i+1; a++) {
    		for(int b = j-1; b <= j+1; b++) {
    			if(hist[a][b] < level)
    				less++;
    			else if(hist[a][b] > level)
    				greater++;
    			else
    				equal++;
    		}
    	}
    	
    	if(less < 9 && greater < 9 && equal < 9)
    		return true;
    	return false;
    }
    
    public static boolean atLevel(int[][] hist, int i, int j, int[] levels) {
		for(int l = 0; l < levels.length; l++) {			
			if(isIsect(hist, i, j, levels[l])) {
				return true;
			}

			/*if(hist[i][j] == levels[l])
				return true;*/
		}

		return false;
	}
}