/////////////////////////
//Region used to gate FACS data

package FACS.Plot;

import java.util.Hashtable;

public class Region implements java.io.Serializable {
	private static final long serialVersionUID = 1L;
	public static final int NONE = 0;
    public static final int ELLIPSE = 1;
    public static final int RECT = 2;
    public static final int POLY = 3;
    public static final int QUAD = 4;
    public static final int RANGE = 5;

	String name;
	Hashtable values;

	public Region() {
	}

	public Region(double[] vals, String name) { //new region -> automatically global
		values = new Hashtable();
		values.put("_global",vals);
		this.name = name;
	}

	public void setValues(Hashtable values) {
		this.values = values;
	}

	public void setVals(String file, double[] vals) {
		if(values.containsKey(file))
			values.put(file,vals);
		else
			values.put("_global",vals);
	}

	public boolean isGlobal(String file) {
		if(values.containsKey(file))
			return false;
		return true;
	}

	public void setGlobal(String file, boolean g) {
		if(g) { //make global
			values.remove(file);
		} else {
			values.put(file,values.get("_global"));
		}
	}

	public void setName(String name) {
		this.name = name;
	}

	public double[] getVals(String file) {
		if(values.containsKey(file))
			return (double[])values.get(file);
		else
			return (double[])values.get("_global");
	}

	public String getName() {
		return name;
	}

	public Hashtable getValues() {
		return values;
	}

	public Object clone() {
		Region r = new Region();
		r.name = name;
		r.values = (Hashtable)values.clone();
		return r;
	}
}