////////////////////
//HeaderBean
// returns FCS header information for a given file
///////////////////

package FACS.Plot;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import javax.naming.Context;
import java.beans.XMLDecoder;

public class Regionlet extends HttpServlet {
	private static String ROOT;

	public static final java.beans.ExceptionListener el = new java.beans.ExceptionListener() {
			public void exceptionThrown(Exception exception) {
				exception.printStackTrace();
			}
		};

	public Regionlet() {
		super();

		try {
			Context c = new javax.naming.InitialContext();
			ROOT = (String)c.lookup("java:comp/env/fcsroot");
		} catch (javax.naming.NamingException ne) {
			ne.printStackTrace();
			ROOT = "";
		}
	}

	public void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		doPost(request,response);
	}

	public void doPost(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		File directory = new File(ROOT,request.getParameter("directory"));
		File xml = new File(directory,"regions.xml");
		
		RVector regions = getRegions(xml);
		
		ObjectOutputStream oos = new ObjectOutputStream(new BufferedOutputStream(response.getOutputStream()));
		try {
			oos.writeObject(regions);
			oos.flush();
		} catch (IOException ioe) {
			ioe.printStackTrace();
			return;
		}
		oos.close();
	}

	public RVector getRegions(File xml) {
		RVector out = new RVector();
		try {
			XMLDecoder d = new XMLDecoder(new BufferedInputStream(new FileInputStream(xml)));
			d.setExceptionListener(el);
			while(true) {
				try {
					out.add((Region)d.readObject());
				} catch(ArrayIndexOutOfBoundsException aioobe) { //file is read completely
					d.close();
					break;
				}
			}
		} catch (FileNotFoundException fnfe) { //throws a FileNotFoundException
		}
		return out;
	}

}