<%@ page import="java.io.*, java.util.*, FACS.Population, FACS.XMLFiles, FACS.UserTools" %>

<%
if(!UserTools.isLoggedIn(request.getCookies())) {
	response.sendRedirect("login.jsp");
	return;
}
String curUser = UserTools.getUser(request.getCookies());

String ROOT;
try {
	javax.naming.Context c = new javax.naming.InitialContext();
	ROOT = (String)c.lookup("java:comp/env/fcsroot");
} catch (javax.naming.NamingException ne) {
	ne.printStackTrace();
	ROOT = "";
}

int perm = UserTools.getUserPermission(request.getParameter("dir"),ROOT,curUser);
if(perm < UserTools.EDIT_PERM) {
	response.sendRedirect("index.jsp");
	return;
}
%>
<html><head><title>Set Up Compensation</title>
<script language="JavaScript">
function onSubmitForm() {
	if(document.pressed == "Edit") {
		document.myform.action = "";
	} else {
		document.myform.action = "cgate.jsp?dir=<%= request.getParameter("dir") %>&mode=new";
	}
}

function openWindow(URL) {
	window.open(URL,"mywindow","menubar=1,resizable=1,width=400,height=450");
}

function copySelection(name1) {
	var prefix = name1.substring(0,name1.length-1);
	var name2;
	if(name1.charAt(name1.length-1) == "P") {
		name2 = prefix+"N";
	} else {
		name2 = prefix+"P";
	}
	var other = document.myform.elements[name2];
	if(other.value == "")
		other.value = document.myform.elements[name1].value;
}
</script>
</head>
<%!
public String printFileSelect(String name, Vector files, Hashtable annos, String anno, String selected) {
	StringBuffer b = new StringBuffer();
	b.append("<Select name=\""+name+"\" onChange=\"copySelection('"+name+"')\">\n");
	b.append("<Option value=\"\">\n");
	for(int i = 0; i < files.size(); i++) {
		String fname = (String)files.elementAt(i);
		String r = fname;
		if(anno != null)
			r = (String)((Hashtable)annos.get(r)).get(anno);
		if(fname.equals(selected))
			b.append("<Option selected value=\""+fname+"\"> "+r+"\n");
		else
			b.append("<Option value=\""+fname+"\"> "+r+"\n");
	}
	b.append("</Select>");
	return b.toString();
}

public String printAnnoSelect(Hashtable annos, String selected) { //(from annotations of first file...)
	StringBuffer b = new StringBuffer();
	Vector k = new Vector(annos.keySet());
	Collections.sort(k);
	b.append("<Select name=\"anno\" onChange=\"document.pressed='Edit'; document.myform.submit();\">\n");
	for(int i = 0; i < k.size(); i++) {
		String anno = (String)k.elementAt(i);
		boolean select = false;
		if(selected != null)
			select = anno.equals(selected);
		else
			select = anno.equals("filename");
		if(select)
			b.append("<Option selected> "+anno+"\n");
		else
			b.append("<Option> "+anno+"\n");
	}
	b.append("</Select>");
	return b.toString();
}

%>

<%
File xml;

String dir = request.getParameter("dir");

Vector pops = XMLFiles.getPopulations(ROOT,dir);
Vector files = XMLFiles.getFiles(ROOT,dir);
Hashtable annos = XMLFiles.getAnnotations(ROOT,dir);
if(annos == null || annos.isEmpty()) {
%>
	<h3>Error: experiment must be annotated before compensation.</h3>
	<i>Please annotate by clicking <a href="Annotator.jsp?dir=<%= dir %>">here</a>.</i>
<%
	return;
}
%>
<h1 align=center>Compensation</h1>
<a href="expt.jsp?dir=<%= dir %>">Back</a><p>
<form name="myform" onSubmit="return onSubmitForm()" method="post">
<%
Hashtable h1 = (Hashtable)annos.get(files.elementAt(0));
%>
<em>Display annotation: <%= printAnnoSelect(h1,request.getParameter("anno")) %></em>
<table width=40% border cellspacing=0>
<tr>
<td>Parameter</td><td><p align=center><font size=5><em>+ve</em></font></p></td>
<td><p align=center><font size=5><em>-ve</em></font></p></td>
</tr>
<%
int ssc = 0;
while(h1.containsKey("P"+(ssc+1))) {
	if(((String)h1.get("P"+(ssc+1))).toUpperCase().startsWith("SSC"))
		break;
	ssc++;
}

int i = 0;
while(h1.containsKey("P"+(i+1))) {
	String pname = XMLFiles.htmlEncode((String)h1.get("P"+(i+1)));
	String sel_P = request.getParameter("p"+i+"P");
	if(request.getParameter("p"+i+"P") == null)
		sel_P = XMLFiles.getFileByPop(pops, "p"+i+"P");
	String sel_N = request.getParameter("p"+i+"N");
	if(request.getParameter("p"+i+"N") == null)
		sel_N = XMLFiles.getFileByPop(pops, "p"+i+"N");

	%>

	<tr>
	<td><%= ("P"+(i+1)+": "+pname) %></td>
	<td><%= printFileSelect("p"+i+"P",files,annos,request.getParameter("anno"),sel_P) %>
		<input type=button value="Gate" onClick="openWindow('PlotApplet.jsp?dir=<%= dir %>&file='+document.myform.<%= "p"+i+"P" %>.value+'&region=<%= "p"+i+"P" %>&param1=<%= i %>&param2=<%= ssc %>&comp=false')"></td>
	<td><%= printFileSelect("p"+i+"N",files,annos,request.getParameter("anno"),sel_N) %>
		<input type=button value="Gate" onClick="openWindow('PlotApplet.jsp?dir=<%= dir %>&file='+document.myform.<%= "p"+i+"N" %>.value+'&region=<%= "p"+i+"N" %>&param1=<%= i %>&param2=<%= ssc %>&comp=false')"></td>
	</tr>
	<%
	i++;
}
%>
<tr>
<td>Universal Negative</td>
<td>&nbsp;</td>
<%
String sel_N = request.getParameter("pN");
if(request.getParameter("pN") == null)
	sel_N = XMLFiles.getFileByPop(pops, "pN");
%>
<td><%= printFileSelect("pN",files,annos,request.getParameter("anno"),sel_N) %>
	<input type=button value="Gate" onClick="openWindow('PlotApplet.jsp?dir=<%= dir %>&file='+document.myform.<%= "pN" %>.value+'&region=<%= "pN" %>&param1=-1&param2=-1&comp=false')"></td>
</tr>
</table>
<input type=hidden name="nPops" value=<%= i %>>
<input type=submit value="Compensate" onClick="document.pressed=this.value">
</form>
<a href="entercomp.jsp?dir=<%= dir %>">Manually Enter Matrix</a>
<body>
</body>
</html>