<%--User changed compensation matrix manually (came from cstatus.jsp)--%>
<%@ page import="java.beans.XMLDecoder, java.io.*, java.util.Vector, FACS.Population, FACS.XMLFiles, FACS.UserTools" %>
<%
String ROOT;
try {
	javax.naming.Context c = new javax.naming.InitialContext();
	ROOT = (String)c.lookup("java:comp/env/fcsroot");
} catch (javax.naming.NamingException ne) {
	ne.printStackTrace();
	ROOT = "";
}

if(!UserTools.isLoggedIn(request.getCookies())) {
	response.sendRedirect("login.jsp");
	return;
}
String curUser = UserTools.getUser(request.getCookies());

int perm = UserTools.getUserPermission(request.getParameter("dir"),ROOT,curUser);
if(perm < UserTools.EDIT_PERM) {
	response.sendRedirect("index.jsp");
	return;
}
%>
<%
String dir = request.getParameter("dir");

//save compensation matrix
int nParams = new Integer(request.getParameter("nPops")).intValue();
double[][] c = new double[nParams][nParams];
for(int i = 0; i < nParams; i++) {
	for(int j = 0; j < nParams; j++) {
		c[i][j] = new Double(request.getParameter(i+","+j)).doubleValue() / 100d; //remember, were displayed as percents
	}
}

XMLFiles.saveComp(ROOT,dir,c);

if(request.getParameter("manual") != null && request.getParameter("manual").equals("true")) { //if user is entering matrix manually, then we're done here
	response.sendRedirect("entercomp.jsp?dir="+dir);
	return;
}


File xml = new File(ROOT+dir,"pops.xml");
XMLDecoder d = new XMLDecoder(new BufferedInputStream(new FileInputStream(xml)));
d.setExceptionListener(new java.beans.ExceptionListener() {
	public void exceptionThrown(Exception exception) {
		exception.printStackTrace();
	}
});
Vector pops = new Vector();
while(true) {
	try {
		Population p = (Population)d.readObject();
		if(p.getName().matches("^p\\d[PN]$") && p.isComp()) { //add compensated populations (of comp samples)
			pops.add(p);
		}
	} catch(ArrayIndexOutOfBoundsException aioobe) { //file is read completely
		d.close();
		break;
	}
}

//actual gating
 session.removeAttribute("comptask"); %>

<jsp:useBean id="comptask" scope="session"
    class="FACS.GaterBean"/>

<% 
comptask.setPops(pops); //only do compensation populations
comptask.setDir(ROOT,dir);
comptask.setRunning(true);
%>

<% new Thread(comptask).start(); %>

<jsp:forward page="cstatus.jsp?mode=done"/>
