<%--this page forwards to gstatus.jsp after it writes the populations in pops.xml--%>
<%@ page import="java.io.*, java.util.*, java.beans.XMLDecoder, FACS.Annotator.Plate, FACS.Population, FACS.XMLFiles, FACS.UserTools" %>
<%!
//for these, I assume that the row letter is one character long
public int getRow(String well) {
	char r = well.charAt(0);
	int a = (int)new Character('A').charValue();
	int i = (int)new Character(r).charValue();

	return (i-a);
}

public int getCol(String well) {
	return new Integer(well.substring(1)).intValue()-1;
}
%>
<%
if(!UserTools.isLoggedIn(request.getCookies())) {
	response.sendRedirect("login.jsp");
	return;
}
String curUser = UserTools.getUser(request.getCookies());

String ROOT;
try {
	javax.naming.Context c = new javax.naming.InitialContext();
	ROOT = (String)c.lookup("java:comp/env/fcsroot");
} catch (javax.naming.NamingException ne) {
	ne.printStackTrace();
	ROOT = "";
}

int perm = UserTools.getUserPermission(request.getParameter("dir"),ROOT,curUser);
if(perm < UserTools.EDIT_PERM) {
	response.sendRedirect("index.jsp");
	return;
}
%>

<%
File xml;

String dir = request.getParameter("dir");
if(request.getParameter("mode") != null && request.getParameter("mode").equals("new")) { //write pops.xml (came from Populations.jsp)
	Vector pops = new Vector();
	Vector plates = XMLFiles.getPlates(ROOT, dir);

	//read in pops.xml to get compensation populations (since those aren't sent from Populations.jsp)
	pops = XMLFiles.getPopulationsComp(ROOT,dir,true);

	//get populations data from Populations.jsp
	for(int i = 0; i < new Integer(request.getParameter("nPops")).intValue(); i++) {
		if(request.getParameter("name_"+i).equals(""))
			continue;

		Vector gates = new Vector();
		int j = 0;
		while(request.getParameter("g_"+i+"_"+j) != null && !request.getParameter("g_"+i+"_"+j).trim().equals("")) {
			gates.add(request.getParameter("g_"+i+"_"+j));
			j++;
		}

		Vector files = new Vector();
		String[] pl = request.getParameter("cb_"+i).split(";");
		for(j = 0; j < pl.length; j++) {
			String[] pcs1 = pl[j].split(":");
			Plate p = XMLFiles.getPlate(plates,pcs1[0]);
			if(pcs1.length < 2)
				continue;
			String[] pcs2 = pcs1[1].split(",");
			for(int k = 0; k < pcs2.length; k++) {
				files.add(p.getFileName(getRow(pcs2[k]),getCol(pcs2[k])));
			}
		}
		pops.add(new Population(request.getParameter("name_"+i), gates, files, true));
	}
%><%
	//write XML file
	XMLFiles.savePops(ROOT,dir,pops);

	//since this function redoes all populations, we can delete stats.xml
	new File(ROOT+dir,"stats.xml").delete();
	//also delete changed regions file
	new File(ROOT+dir,"rchanged.xml").delete();
}

%><%

//read in pops.xml
Vector pops = XMLFiles.getPopulationsComp(ROOT,dir,false);

if(request.getParameter("mode") != null && request.getParameter("mode").equals("update")) { //only a few gates changed
	//set pops Vector to relevant populations
	//then edit populations' files Vector for relevant files

	Hashtable rchanged;
	xml = new File(ROOT+dir,"rchanged.xml");
	try {
		XMLDecoder d = new XMLDecoder(new BufferedInputStream(new FileInputStream(xml)));
		rchanged = (Hashtable)d.readObject();
	} catch (FileNotFoundException nfe) {
		%>
		<h2>No populations need updating.</h2>
		<%
		return;
	}

	Vector pops2 = new Vector();
	for(Enumeration e = rchanged.keys(); e.hasMoreElements(); ) { //for each gate
		String gatename = (String)e.nextElement();
		Vector pp = XMLFiles.getPopsByGate(pops,gatename);
		for(int pi = 0; pi < pp.size(); pi++) { //for all populations that use that gate
			Population p = (Population)((Population)pp.elementAt(pi)).clone();
			TreeSet fileset = (TreeSet)rchanged.get(gatename);
			if(XMLFiles.getPopulation(pops2,p.getName()) == null) { //[see else for explanation]
				if(!fileset.contains("_global")) //if global changed, will just re-gate all files (thus, use default)
					p.setFiles(new Vector(fileset));
				pops2.add(p);
			} else { //population already added, need to augment files list
				if(!fileset.contains("_global"))
					p.getFiles().addAll(fileset);
				else //need to re-add ALL files (just assume they may have been removed...)
					p.setFiles(XMLFiles.getPopulation(pops,p.getName()).getFiles());
			}
		}
	}
	pops = pops2;
	xml.delete();
}
%>

<%//actual gating
 session.removeAttribute("task");
 String s = "gstatus.jsp?dir="+request.getParameter("dir"); %>

<jsp:useBean id="task" scope="session"
    class="FACS.GaterBean"/>

<% 
task.setPops(pops);
task.setDir(ROOT,dir);
task.setRunning(true);
%>

<% new Thread(task).start(); %>

<jsp:forward page="<%= s %>"/>