<%@ page contentType="image/svg+xml" %><?xml version="1.0" encoding="UTF-8"?>
<%@ page import="java.util.*" %>
<%! static Vector colors; %>

<%
/*if(colors == null) {
	colors = new Vector();
	colors.add("purple");
	colors.add("maroon");
	colors.add("navy");
	colors.add("olive");
	colors.add("lime");
}*/
%>
<svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" xml:space="preserve" version="1.1"  baseProfile="full">
<g transform="translate(25,25)">
<%
int width = 500-50;
int height = 400-50;
%>
<g fill="none" stroke="black">
<rect x="0" y="0" width="<%= width %>" height="<%= height %>" />
</g>
<%
int xaxis = new Integer(request.getParameter("x-axis")).intValue();
xaxis--;
int yaxis = new Integer(request.getParameter("y-axis")).intValue();
yaxis--;

double xmax = Double.NaN;
if(!request.getParameter("xmax").equals(""))
	xmax = new Double(request.getParameter("xmax")).doubleValue();
double ymax = Double.NaN;
if(!request.getParameter("ymax").equals(""))
	ymax = new Double(request.getParameter("ymax")).doubleValue();
double xmin = Double.NaN;
if(!request.getParameter("xmin").equals(""))
	xmin = new Double(request.getParameter("xmin")).doubleValue();
double ymin = Double.NaN;
if(!request.getParameter("ymin").equals(""))
	ymin = new Double(request.getParameter("ymin")).doubleValue();
double xrange;
double yrange;
double xminold;
double yminold;

boolean xlog = false;
if(!request.getParameter("xlog").equals("null"))
	xlog = true;
boolean ylog = false;
if(!request.getParameter("ylog").equals("null"))
	ylog = true;

Vector series = (Vector)session.getAttribute(request.getParameter("t"));
session.setAttribute(request.getParameter("t"),null);

Hashtable xdata = null, ydata = null;
if(xaxis != -1)
	xdata = (Hashtable)series.elementAt(xaxis);
if(yaxis != -1)
	ydata = (Hashtable)series.elementAt(yaxis);
Vector keys = null;
if(xaxis == -1 && yaxis == -1) {
	%>
	<text x="100" y="100">Error: Need at least one data axis.</text>
	</g>
	</svg>
	<%
	return;
}
if(xaxis == -1) {
	keys = new Vector();
	for(Enumeration e = ydata.keys(); e.hasMoreElements(); )
		keys.add(e.nextElement());
	Collections.sort(keys, new ForcedNumberComparator());
}
if(yaxis == -1) {
	keys = new Vector();
	for(Enumeration e = xdata.keys(); e.hasMoreElements(); )
		keys.add(e.nextElement());
	Collections.sort(keys, new ForcedNumberComparator());
}

try {
	if(Double.isNaN(xmax)) {
		if(xaxis == -1)
			xmax = new Double(((String)keys.lastElement()).replaceAll("[^0-9.]","")).doubleValue();
		else
			xmax = getMax(xdata.elements());
	}
	if(Double.isNaN(xmin)) {
		if(xaxis == -1)
			xmin = new Double(((String)keys.firstElement()).replaceAll("[^0-9.]","")).doubleValue();
		else
			xmin = getMin(xdata.elements());
	}
	if(Double.isNaN(ymax)) {
		if(yaxis == -1)
			ymax = new Double(((String)keys.lastElement()).replaceAll("[^0-9.]","")).doubleValue();
		else
			ymax = getMax(ydata.elements());
	}
	if(Double.isNaN(ymin)) {
		if(yaxis == -1)
			ymin = new Double(((String)keys.firstElement()).replaceAll("[^0-9.]","")).doubleValue();
		else
			ymin = getMin(ydata.elements());
	}


	xrange = xmax-xmin;
	xminold = xmin;
	yrange = ymax-ymin;
	yminold = ymin;
} catch (NumberFormatException nfe) {
	%>
	<text x="100" y="100">Error: Keys cannot be resolved to numbers.</text>
	</g>
	</svg>
	<%
	return;
}

if(xlog) {
	xmax = Math.log(xmax);
	xmin = Math.log(xmin);
}
if(ylog) {
	ymax = Math.log(ymax);
	ymin = Math.log(ymin);
}

%>
<g fill="blue" stroke="blue">
<%

if(xaxis != -1 && yaxis != -1) {
	Enumeration e = xdata.keys();
	while(e.hasMoreElements()) {
		String key = (String)e.nextElement();
		double x = ((Double)xdata.get(key)).doubleValue();
		if(xlog)
			x = Math.log(x);
		double y = ((Double)ydata.get(key)).doubleValue();
		if(ylog)
			y = Math.log(y);

		x -= xmin;
		x /= (xmax-xmin);
		x *= width;
		y -= ymin;
		y /= (ymax-ymin);
		y *= height;
		y = height-y; %>
		
		<rect x="<%= x-2.5 %>" y="<%= y-2.5 %>" width="5" height="5"/>  

<%	}
} else {
	Enumeration e = keys.elements();
	while(e.hasMoreElements()) {
		String key = (String)e.nextElement();
		double x,y;
		if(xaxis == -1) {
			x = new Double(key.replaceAll("[^0-9.]","")).doubleValue();
			y = ((Double)ydata.get(key)).doubleValue();
		} else {
			y = new Double(key.replaceAll("[^0-9.]","")).doubleValue();
			x = ((Double)xdata.get(key)).doubleValue();
		}

		if(xlog)
			x = Math.log(x);
		if(ylog)
			y = Math.log(y);

		x -= xmin;
		x /= (xmax-xmin);
		x *= width;
		y -= ymin;
		y /= (ymax-ymin);
		y *= height;
		y = height-y; %>
		
		<rect x="<%= x-2.5 %>" y="<%= y-2.5 %>" width="5" height="5"/>  

<%	}
}
%>
</g>
<g fill="none" stroke="black">
<% //X Axis
int X_AXIS = 20;
double y = height;
double last_x = 0;
for(int i = 0; i <= X_AXIS; i++) {
	double x = (double)i/(double)X_AXIS*xrange+xminold;
	if(xlog)
		x = Math.log(x);
	x -= xmin;
	x /= (xmax-xmin);
	x *= width;
	%>
	<% if(x-last_x > 50 || last_x==0) { %>
		<line x1="<%= x %>" y1="<%= y %>" x2="<%= x %>" y2="<%= y+20 %>" />
		<text x="<%= x %>" y="<%= y+20 %>" font-size="10" font="Verdana"><%= round((double)i/(double)X_AXIS*xrange+xminold,2) %></text>
	<%	last_x = x;
	} else { %>
		<line x1="<%= x %>" y1="<%= y %>" x2="<%= x %>" y2="<%= y+10 %>" />
	<% } %>
<% } %>
<% //Y Axis
int Y_AXIS = 20;
double x = -24;
double last_y = 0;
for(int i = 0; i <= Y_AXIS; i++) {
	y = (double)i/(double)Y_AXIS*yrange+yminold;
	if(ylog)
		y = Math.log(y);
	y -= ymin;
	y /= (ymax-ymin);
	y *= height;
	y = height-y;
	%>
	<% if(last_y-y > 50 || last_y==0 || y == 0) { %>
		<line x1="<%= y==0 ? x+15 : x %>" y1="<%= y %>" x2="<%= x+24 %>" y2="<%= y %>" />
		<text x="<%= x %>" y="<%= y+10 %>" font-size="10" font="Verdana"><%= round((double)i/(double)Y_AXIS*yrange+yminold,2) %></text>
	<%	last_y = y;
	} else { %>
		<line x1="<%= x+15 %>" y1="<%= y %>" x2="<%= x+24 %>" y2="<%= y %>" />
	<% } %>
<% } %>
</g>
</g>
</svg>

<%!
class ForcedNumberComparator implements Comparator, java.io.Serializable {
	public int compare(Object o1, Object o2) {
		String s1 = (String)o1;
		String s2 = (String)o2;
		s1 = s1.replaceAll("[^0-9.]","");
		s2 = s2.replaceAll("[^0-9.]","");
		try {
			double d1 = new Double(s1).doubleValue();
			double d2 = new Double(s2).doubleValue();
			return Double.compare(d1,d2);
		} catch (NumberFormatException nfe) {
			return 0;
		}
	}
}

public String round(double in, int dec) {
	in *= Math.pow(10,dec);
	double out = (Math.rint(in))/Math.pow(10,dec);
	return new Double(out).toString();
}

public double getMax(Enumeration e) {
	double max = ((Double)e.nextElement()).doubleValue();
	while(e.hasMoreElements()) {
		double test = ((Double)e.nextElement()).doubleValue();
		if(test > max)
			max = test;
	}
	return max;
}

public double getMin(Enumeration e) {
	double min = ((Double)e.nextElement()).doubleValue();
	while(e.hasMoreElements()) {
		double test = ((Double)e.nextElement()).doubleValue();
		if(test < min)
			min = test;
	}
	return min;
}
%>